Last Comment Bug 700517 - Add "ret imm16" instruction for x86 and x86-64.
: Add "ret imm16" instruction for x86 and x86-64.
Status: RESOLVED FIXED
:
Product: Core
Classification: Components
Component: JavaScript Engine (show other bugs)
: unspecified
: x86 All
: -- normal (vote)
: mozilla11
Assigned To: Nicolas B. Pierron [:nbp]
:
Mentors:
Depends on:
Blocks: IonMonkey
  Show dependency treegraph
 
Reported: 2011-11-07 17:02 PST by Nicolas B. Pierron [:nbp]
Modified: 2012-02-01 13:59 PST (History)
3 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
MC patch, Add retn. (2.06 KB, patch)
2011-11-07 17:47 PST, Nicolas B. Pierron [:nbp]
dvander: review+
emorley: checkin+
Details | Diff | Review
IM patch, Add retn. (1.13 KB, patch)
2011-11-07 17:53 PST, Nicolas B. Pierron [:nbp]
dvander: review+
Details | Diff | Review

Description Nicolas B. Pierron [:nbp] 2011-11-07 17:02:39 PST
IonMonkey has wrapper functions around C/C++ function calls.  Arguments are pushed to these wrappers and the wrappers are in charge of getting rid of the space reserved for the arguments, to reduce the space consumed inside the Jitted code.

Currently, a hack is done to unwind the arguments and copy the return address at the top level.  The "ret imm16" handle such case and we should use it to unwind list of arguments known at compile time.
Comment 1 Nicolas B. Pierron [:nbp] 2011-11-07 17:47:41 PST
Created attachment 572696 [details] [diff] [review]
MC patch, Add retn.
Comment 2 Nicolas B. Pierron [:nbp] 2011-11-07 17:53:00 PST
Created attachment 572698 [details] [diff] [review]
IM patch, Add retn.
Comment 3 David Anderson [:dvander] 2011-11-07 17:56:46 PST
Comment on attachment 572698 [details] [diff] [review]
IM patch, Add retn.

Review of attachment 572698 [details] [diff] [review]:
-----------------------------------------------------------------

Prefer if this was named "retn" instead to match Intel syntax, but this is not a strong preference.
Comment 4 Ed Morley [:emorley] 2011-12-12 18:08:36 PST
https://tbpl.mozilla.org/?tree=Try&rev=73b8ab2861e1

Will push tomorrow presuming green :-)
Comment 5 Ed Morley [:emorley] 2011-12-13 06:29:12 PST
Comment on attachment 572696 [details] [diff] [review]
MC patch, Add retn.

https://hg.mozilla.org/mozilla-central/rev/e3eaae25901c

Note You need to log in before you can comment on or make changes to this bug.